<?php

/**************************************************************
 * $File: //depot/povray/tools/wiki-docgen/createSubIndex.php $
 * $Revision: #1 $
 * $Change: xxxx $
 * $DateTime: 2015/02/09 18:00:00 $
 * $Author: jholsenback $
 *************************************************************/

ini_set("display_errors", "stdout");

// initialize
$File = '';
$FileList = '';
$InputFile = '';
$OutputFile = '';
$Linesworth = '';
$Pattern = '';
$IndexList = array();
$Counter = 0;
$Entry = 0;

class TagMap {

	public function getTagType() {
		return $this->TagType;
		}

	public function setTagType ($Type) {
		$this->TagType = $Type;
		}

	public function getParent() {
		return $this->Parent;
		}

	public function setParent ($Tag) {
		$this->Parent = $Tag;
		}

	public function getChild() {
		return $this->Child;
		}

	public function setChild ($Tag) {
		$this->Child = $Tag;
		}

	public function getPageName() {
		return $this->PageName;
		}

	public function setPageName ($PageName) {
		$this->PageName = $PageName;
		}

	public function getItemIndex() {
		return $this->ItemIndex;
		}

	public function setItemIndex ($ItemIndex) {
		$this->ItemIndex = $ItemIndex;
		}
	} // end of class TagMap

function ParseTags ($Entry, $File, $Linesworth, $Tags, $Counter, $IndexList) {
$Tag = '';
$Pattern = '';

	foreach ($Tags as $Tag) {
		//echo $Tag."\n";
		if (strpos($Tag,'indexentry') == true) {
			// don't care - do nothing
			}
		// *********************
		// Multi-Topic-Index Tag
		elseif (strpos($Tag,'|') == true) {
			if (strpos($Tag,',') == true) {
				//echo "Multi-Topic-Index Tag: [".$Tag."] found in file: ".$File."\n";
				}
			else {
				// DONE: the case of simple multi-topic tags
				//echo "Simple Multi-Topic Tag: [".$Tag."] found in file: ".$File."\n";
				$Topics = explode ("|", $Tag,6);
				foreach ($Topics as $Topic) {
					$IndexList[$Entry] = new TagMap ();
					$IndexList[$Entry]->setTagType ("Multi-Topic");
					$IndexList[$Entry]->setParent ($Topic);
					$IndexList[$Entry]->setChild (''); // Simple multi-topic tags have no children
					$IndexList[$Entry]->setPageName ($File);
					$IndexList[$Entry++]->setItemIndex ($Counter); // Don't advance Counter here ...
					// because because multi-topic tags should point to the same index
					}
				$Linesworth = "<a name=\"ndxntry_".$Counter."\" "."id=\"ndxntry_".$Counter++."\"></a>";
				}
			}
		// ***************
		// Multi-Index Tag
		elseif (strpos($Tag,',') == true) { // this is the biggest type of tag
			//echo "Multi-Index Tag: [".$Tag."] found in file: ".$File."\n";
			}
		// **********
		// Simple Tag
		else {
			// DONE: the case of simple one topic tags
			//echo "Simple Tag: [".$Tag."] found in file: ".$File."\n";
			$IndexList[$Entry] = new TagMap ();
			$IndexList[$Entry]->setTagType ("Simple");
			$IndexList[$Entry]->setParent ($Tag);
			$IndexList[$Entry]->setChild (''); // Simple one topic tags have no children
			$IndexList[$Entry]->setPageName ($File);
			$IndexList[$Entry++]->setItemIndex ($Counter);

			$Pattern = '\{\{#indexentry:([a-zA-Z0-9 \/+.#_\-]+)\}\}';
			$Linesworth = preg_replace ("/$Pattern/",
				"<a name=\"ndxntry_".$Counter."\" "."id=\"ndxntry_".$Counter++."\"></a>", $Linesworth);
			}
		}
	
	return array ($Linesworth, $IndexList, $Counter, $Entry);
	} // end of function ParseTags

function ListFiles ($Directory) {
$Ndx = 0;
$Files = '';
$FileList = '';

	$Files = scandir ($Directory);
	foreach ($Files as $File) {
		if (strpos($File,'.html') == true) {
			$FileList[$Ndx] = $File;
			$Ndx = $Ndx + 1;
			}
		}
	return ($FileList);
	} // end of function ListFiles


// -------------------------
// Begin main execution here
// -------------------------

$FileList = ListFiles ("./tagged");
$Pattern = '\{\{#indexentry:([a-zA-Z0-9 \"\/|:+,.#_\-]+)\}\}';

if ($FileList) {
	foreach ($FileList as $File) {
		$InputFile = fopen ("./tagged/".$File, "rt") or die ("Could not open ./tagged/".$File."\n");
		$OutputFile = fopen ("./indexed/".$File, "wt") or die ("Could not open ./indexed/".$File."\n");
		while (!feof ($InputFile)) {
			$Linesworth = fgets ($InputFile);
			if (preg_match(("/$Pattern/"), $Linesworth, $Tags)) {
				list ($Linesworth, $IndexList, $Counter, $Entry) = 
					ParseTags ($Entry, $File, $Linesworth, $Tags, $Counter, $IndexList);
				}
			fwrite ($OutputFile, $Linesworth);
			}
		fclose ($InputFile);
		fclose ($OutputFile);
		}
	}
else {
	echo "No files found"."\n";
	exit (0);
	}

asort ($IndexList);

$Prefix = "ndxntry_";
/*foreach ($IndexList as $ListEntry) {
	echo $ListEntry->TagType.": <a href=\"".$ListEntry->getPageName()."#"
	.$Prefix.$ListEntry->getItemIndex()."\">".$ListEntry->getParent()."</a><br>\n";
	}*/

//var_dump ($IndexList);
//echo "Counter:".$Counter."\n";
//echo "Entry:".$Entry."\n";

?>
