<?php

/*********************************************************
 * $File: //depot/povray/tools/wiki-docgen/utilities.php $
 * $Revision: #7 $
 * $Change: 5564 $
 * $DateTime: 2011/11/28 17:30:00 $
 * $Author: jholsenback $
 *********************************************************/

ini_set("display_errors", "stdout");

function BuildIndexPanel ($Platform) {
	if ($Platform == "Windows") {
		$Title = "Windows Table of Contents";
		$Link = "w1_0";
		$URI = "POV-Ray for Windows";
		}
	elseif ($Platform == "Mac OS") {
		$Title = "Mac OS Table of Contents";
		$Link = "m1_0";
		$URI = "POV-Ray for Mac OS";
		}
	elseif ($Platform == "Unix") {
		$Title = "Unix Table of Contents";
		$Link = "u1_0";
		$URI = "POV-Ray for Unix";
		}

	$FixedPanel = "<!-- NavPanel Begin -->\n";
	$FixedPanel = $FixedPanel."<div class=\"NavPanel\">\n<table class=\"NavTable\">\n<tr>\n";
	$FixedPanel = $FixedPanel."  <td class=\"FixedPanelHeading\">";
	$FixedPanel = $FixedPanel."<a title=\"You're already here!\" href=\"index.html\">Home</a></td>\n</tr>\n";
	$FixedPanel = $FixedPanel."<tr>\n  <td><div class=\"divh2\">";
	$FixedPanel = $FixedPanel."<a title=\"".$Title."\" href=\"".$Link.".html\">".$URI."</a></div></td>\n</tr>\n";
	$FixedPanel = $FixedPanel."<tr>\n  <td><div class=\"divh2\">";
	$FixedPanel = $FixedPanel."<a title=\"Tutorial Table of Contents\" href=\"t2_0.html\">POV-Ray Tutorial</a></div></td>\n</tr>\n";
	$FixedPanel = $FixedPanel."<tr>\n  <td><div class=\"divh2\">";
	$FixedPanel = $FixedPanel."<a title=\"Reference Table of Contents\" href=\"r3_0.html\">POV-Ray Reference</a></div></td>\n</tr>\n";
	$FixedPanel = $FixedPanel."</table>\n</div>\n";
	$FixedPanel = $FixedPanel."<!-- NavPanel End -->\n\n";

	return $FixedPanel;
	}

function FixLinkTitle ($Page, $OutFile) {
$Pattern = "";

	if ( preg_match ("/^w/", $OutFile) ) {
		$Pattern = 'title=\"Windows Table of Contents\"';
		}
	elseif ( preg_match ("/^m/", $OutFile) ) {
		$Pattern = 'title=\"Mac OS Table of Contents\"';
		}
	elseif ( preg_match ("/^u/", $OutFile) ) {
		$Pattern = 'title=\"Unix Table of Contents\"';
		}
	elseif ( preg_match ("/^t/", $OutFile) ) {
		$Pattern = 'title=\"Tutorial Table of Contents\"';
		}
	elseif ( preg_match ("/^r/", $OutFile) ) {
		$Pattern = 'title=\"Reference Table of Contents\"';
		}
	elseif ( preg_match ("/^i/", $OutFile) ) {
		$Pattern = 'title=\"The Front Door\"';
		}
	
	$Message = 'title="You\'re already here!"';
	$Page = preg_replace ("/$Pattern/", $Message, $Page);
	return $Page;
	}

function FixStyleKeyword ($Page) {
$Pattern = "";
$Repaired = "";

	$Pattern = 'FIXMEoverflow: FIXMEauto;';
	$Repaired = 'overflow: auto;';
	$Page = preg_replace ("/$Pattern/", $Repaired, $Page);
	return $Page;
	}

function ReadPage ($DataBase, $DocNameSpace, $WikiTitle) {
	$Query = 'select old_text from text where old_id=(select rev_text_id ';
	$Query = $Query . 'from revision where rev_id=(select page_latest ';
	$Query = $Query . 'from page where page_title="' . $WikiTitle . '" AND page_namespace="';
	$Query = $Query . $DocNameSpace . '"));';	
	
	$Result = mysql_query($Query)
		or exit (8);

	$Row = mysql_fetch_array($Result, MYSQL_ASSOC);

	mysql_free_result($Result);
	return $Row;
	}

function GatherTOCfiles ($DataBase, $DocNameSpace, $WikiPageTitle) {
$Index = 0;

while ($WikiTitle = current($WikiPageTitle)) {
	// Build the query line
	$Query = 'select old_text from text where old_id=(select rev_text_id ';
	$Query = $Query . 'from revision where rev_id=(select page_latest ';
	$Query = $Query . 'from page where page_title="' . $WikiTitle . '" AND page_namespace="';
	$Query = $Query . $DocNameSpace . '"));';	

	$Result = mysql_query($Query)
		or exit (9);

	// Translate the chapter header
	if ($WikiTitle == "Tutorial_Table_of_Contents") {
		$Title = "Introduction to POV-Ray";
		}
	elseif ($WikiTitle == "Reference_Table_of_Contents") {
		$Title = "POV-Ray Reference";
		}
	elseif ($WikiTitle == "Windows_Table_of_Contents") {
		$Title = "POV-Ray for Windows";
		}
	elseif ($WikiTitle == "Mac_OS_Table_of_Contents") {
		$Title = "POV-Ray for Mac OS";
		}
	elseif ($WikiTitle == "Unix_Table_of_Contents") {
		$Title = "POV-Ray for Unix";
		}
		while ($Pages[$Index] = mysql_fetch_array($Result, MYSQL_ASSOC)) {
		array_unshift ($Pages[$Index++], "=".$Title."=\n"); 
		}
	// Free result set
	mysql_free_result($Result);	

	next ($WikiPageTitle);
	}

mysql_close($DataBase);
return $Pages;
}
// end function GatherTOCfiles

/* Used for regenerating Documentation:Contents */
function BuildWikiTOC ($Pages) {
// Initialzation
$FirstTime = "";
$IsSubsection = "";
$Line = "";
$LinesWorth = "";
$Link = "";
$NewSubsection = "";
$Page = "";
$SSL4 = "";
$SSL3 = "";
$SSL2 = "";
$TOCEntries = "";

$Entry = 0;
$Section = 1;
$SubsectionLevel1 = 1;
$SubsectionLevel2 = 1;
$SubsectionLevel3 = 1;
$SubsectionLevel4 = 1;
$FirstTime = "true";
$NewSubsection = "true";


foreach ($Pages as $Page) {
	if ($Page) {
		foreach ($Page as $Lines) {
			$Line = explode ("\n", $Lines); 
			foreach ($Line as $LinesWorth) {
				// test for line types
				// THIS IS ORDER SPECIFIC

				// sub-section header
				if (preg_match("/^==/", $LinesWorth)) {
					// create a new entry
					$NewSubsection = "true";
					$Subsection++;
					$SubsectionLevel1 = 1;

					$SectionEntry = $Section.".".$Subsection;

					//echo $SectionEntry."\n".$LinesWorth."\n";
					$Link = explode ("==", $LinesWorth);
					$TOCEntries = $TOCEntries.":<strong>".$SectionEntry." ".$Link[1]."</strong>\n";

					}

				// section header (tut, ref, win ...)		
				elseif (preg_match("/^=/", $LinesWorth)) {
					if ($FirstTime) {
						$FirstTime = "";
						$Subsection = 0;
						}
					else {
						$Subsection = 0;
						$Section++;
						}

					if ($IsSubsection) {
						$Subsection = 0;
						$IsSubsection = "";
						}

					$SectionEntry = $Section.".".$Subsection;

					//echo $SectionEntry."\n".$LinesWorth."\n";
					$Link = explode ("=", $LinesWorth);
					$TOCEntries = $TOCEntries."==".$Link[1]."==\n";

					}

				// subsection level 4 header
				elseif (preg_match("/^::::/", $LinesWorth)) {
					$SSL4 = "true";
			
					$SectionEntry = $Section.".".$Subsection.".".($SubsectionLevel1-1).".".($SubsectionLevel2-1).".";
					$SectionEntry = $SectionEntry.($SubsectionLevel3-1).".".$SubsectionLevel4++;

					//echo $SectionEntry.$LinesWorth."\n";
					$Link = explode ("::::* ", $LinesWorth);
					$TOCEntries = $TOCEntries.":::::".$SectionEntry." ".$Link[1]."\n";

					}

				// subsection level 3 header
				elseif (preg_match("/^:::/", $LinesWorth)) {
					$SSL3 = "true";
					if ($SSL4) {
						$SubsectionLevel4 = "1";
						$SSL4 = "";
						}
			
					$SectionEntry = $Section.".".$Subsection.".".($SubsectionLevel1-1).".".($SubsectionLevel2-1).".";
					$SectionEntry = $SectionEntry.$SubsectionLevel3++;

					//echo $SectionEntry.$LinesWorth."\n";
					$Link = explode (":::* ", $LinesWorth);
					$TOCEntries = $TOCEntries."::::".$SectionEntry." ".$Link[1]."\n";
					}

				// subsection level 2 header
				elseif (preg_match("/^::/", $LinesWorth)) {
					$SSL2 = "true";
					if ($SSL3) {
						$SubsectionLevel3 = "1";
						$SSL3 = "";
						}
			
					$SectionEntry = $Section.".".$Subsection.".".($SubsectionLevel1-1).".".$SubsectionLevel2++;

					//echo $SectionEntry.$LinesWorth."\n";
					$Link = explode ("::* ", $LinesWorth);
					$TOCEntries = $TOCEntries.":::".$SectionEntry." ".$Link[1]."\n";
					}

				// subsection level 1 header
				elseif (preg_match("/^:/", $LinesWorth)) {
					if ($SSL2) {
						$SubsectionLevel2 = "1";
						$SSL2 = "";
						}

					if ($NewSubsection) {
						$NewSubsection = "";				
						}
			
					$SectionEntry = $Section.".".$Subsection.".".$SubsectionLevel1++;

					//echo $SectionEntry.$LinesWorth."\n";
					$Link = explode (":* ", $LinesWorth);
					$TOCEntries = $TOCEntries."::".$SectionEntry." ".$Link[1]."\n";
					}
				}	//foreach LinesWorth
			}	//foreach Lines
		}	//if Pages
	}	//foreach Pages

return $TOCEntries;
}
// end function BuildWikiTOC

/* --

	Finds the local filename for a given wiki base filename.

-- */

function LookupLocalFN ($BasePageName, $DocMap) {

foreach ($DocMap as $MapEntry) {
	if ($MapEntry->getWikiFN() == $BasePageName) {
		$LocalFilename = $MapEntry->getLocalFN();
		break;
		}
	}


return $LocalFilename;}
// end of function LookupLocalFN

?>
